# TODO:
# - redefine: PACKAGE_BUGREPORT=cpufreq@vger.kernel.org
# - add -n python-perf?
# - without perf bcond does not work (it still builds it)
# - add bcond to disable building docs (perf docs)
# - install of perf compiles things over again

# Conditional build:
%bcond_without	verbose		# verbose build (V=1)
%bcond_without	perf		# perf tools
%bcond_without	gtk		# GTK+ 2.x perf support

%define		basever		3.17
%define		postver		.3
Summary:	Assortment of tools for the Linux kernel
Summary(pl.UTF-8):	Zestaw narzędzi dla jądra Linuksa
Name:		kernel-tools
Version:	%{basever}%{postver}
Release:	1
License:	GPL v2
Group:		Applications/System
Source0:	https://www.kernel.org/pub/linux/kernel/v3.x/linux-%{basever}.tar.xz
# Source0-md5:	fb30d0f29214d75cddd2faa94f73d5cf
%if "%{postver}" != ".0"
Patch0:		https://www.kernel.org/pub/linux/kernel/v3.x/patch-%{version}.xz
# Patch0-md5:	13f495e3ce72ed6ccefb38591587a6ef
%endif
Source1:	cpupower.service
Source2:	cpupower.config
URL:		http://www.kernel.org/
BuildRequires:	gettext-tools
BuildRequires:	pciutils-devel
BuildRequires:	rpmbuild(macros) >= 1.647
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
%if %{with perf}
BuildRequires:	asciidoc
BuildRequires:	audit-libs-devel
BuildRequires:	binutils-devel
BuildRequires:	bison
BuildRequires:	docbook-dtd45-xml
BuildRequires:	docbook-style-xsl
BuildRequires:	elfutils-devel
BuildRequires:	flex
BuildRequires:	libunwind-devel >= 0.99
BuildRequires:	numactl-devel
BuildRequires:	perl-devel >= 5.1
BuildRequires:	python-devel
BuildRequires:	rpm-pythonprov
BuildRequires:	slang-devel
BuildRequires:	xmlto
%if %{with gtk}
BuildRequires:	gtk+2-devel >= 2.0
BuildRequires:	pkgconfig
%endif
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# otherwise /usr/lib/rpm/bin/debugedit: canonicalization unexpectedly shrank by one character
%define		_enable_debug_packages	0

%define		makeopts	CC="%{__cc}" %{?with_verbose:V=1}

%description
This package contains the software from tools/ subdirectory from Linux
kernel source and the supporting documentation.

%description -l pl.UTF-8
Ten pakiet zawiera oprogramowanie z podkatalogu tools/ ze źródeł jądra
Linuksa oraz związaną z nim dokumentację.

%package cpupower
Summary:	cpupower - Shows and sets processor power related values
Summary(pl.UTF-8):	cpupower - wyświetlanie i ustawianie wartości związanych z zużyciem energii przez procesor
Group:		Applications/System
Requires(post,preun,postun):	systemd-units >= 38
Requires:	%{name}-cpupower-libs = %{version}-%{release}
Requires:	systemd-units >= 0.38
Provides:	cpufreq-utils = 1:009-0.6.p1
Provides:	cpufrequtils = 1:009-0.6.p1
Provides:	cpupowerutils = 1:009-0.6.p1
Obsoletes:	cpufreq-utils < 1:009-0.6.p1
Obsoletes:	cpufrequtils < 1:009-0.6.p1
Obsoletes:	cpupowerutils < 1:009-0.6.p1
Obsoletes:	cpuspeed < 1:1.5-16

%description cpupower
cpupower is a collection of tools to examine and tune power saving
related features of your processor.

%description cpupower -l pl.UTF-8
cpupower to zbiór narzędzi do sprawdzania i ustawiania opcji procesora
związanych z oszczędzaniem energii.

%package cpupower-libs
Summary:	cpupower library
Summary(pl.UTF-8):	Biblioteka cpupower
Group:		Libraries

%description cpupower-libs
cpupower library.

%description cpupower-libs -l pl.UTF-8
Biblioteka cpupower.

%package cpupower-libs-devel
Summary:	Development files for the cpupower library
Summary(pl.UTF-8):	Pliki programistyczne biblioteki cpupower
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-cpupower-libs = %{version}-%{release}
Provides:	cpufrequtils-devel = 1:009-0.6.p1
Provides:	cpupowerutils-devel = 1:009-0.6.p1
Obsoletes:	cpufrequtils-devel < 1:009-0.6.p1
Obsoletes:	cpupowerutils-devel < 1:009-0.6.p1

%description cpupower-libs-devel
Development files for the cpupower library.

%description cpupower-libs-devel -l pl.UTF-8
Pliki programistyczne biblioteki cpupower.

%package perf
Summary:	perf profiler tool
Summary(pl.UTF-8):	Narzędzie profilujące perf
Group:		Applications/System
Suggests:	binutils
Obsoletes:	perf-core
Obsoletes:	perf-slang

%description perf
Perf is a profiler tool for Linux 2.6+ based systems that abstracts
away CPU hardware differences in Linux performance measurements and
presents a simple commandline interface. Perf is based on the
perf_events interface exported by recent versions of the Linux kernel.

This package contains core files, scripts and text interface (TUI).

%description perf -l pl.UTF-8
Perf to narzędzie profilujące dla systemów opartych na Linuksie 2.6+,
odseparowujące od różnic sprzętowych między pomiarami wydajności w
zależności od procesora oraz udostępniające prosty interfejs linii
poleceń. Perf jest oparty na interfejsie perf_events eksportowanym
przez nowe wersje jądra Linuksa.

Ten pakiet zawiera podstawowe pliki, skrypty oraz interfejs tekstowy
(TUI).

%package perf-gtk
Summary:	perf profiler tool (GTK+ 2 GUI)
Summary(pl.UTF-8):	Narzędzie profilujące perf (interfejs graficzny GTK+ 2)
Group:		X11/Applications
Requires:	%{name}-perf = %{version}-%{release}

%description perf-gtk
Perf is a profiler tool for Linux 2.6+ based systems that abstracts
away CPU hardware differences in Linux performance measurements and
presents a simple commandline interface. Perf is based on the
perf_events interface exported by recent versions of the Linux kernel.

This package contains GTK+ 2 based GUI.

%description perf-gtk -l pl.UTF-8
Perf to narzędzie profilujące dla systemów opartych na Linuksie 2.6+,
odseparowujące od różnic sprzętowych między pomiarami wydajności w
zależności od procesora oraz udostępniające prosty interfejs linii
poleceń. Perf jest oparty na interfejsie perf_events eksportowanym
przez nowe wersje jądra Linuksa.

Ten pakiet zawiera graficzny interfejs oparty na GTK+ 2.

%package -n bash-completion-perf
Summary:	Bash completion for perf command
Summary(pl.UTF-8):	Bashowe uzupełnianie parametrów dla polecenia perf
Group:		Applications/Shells
Requires:	%{name}-perf
Requires:	bash-completion
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description -n bash-completion-perf
Bash completion for perf command.

%description -n bash-completion-perf -l pl.UTF-8
Bashowe uzupełnianie parametrów dla polecenia perf.

%prep
%setup -qc
cd linux-%{basever}

%if "%{postver}" != ".0"
%patch0 -p1
%endif

sed -i -e 's#libexec/perf-core#%{_datadir}/perf-core#g' tools/perf/config/Makefile

%build
cd linux-%{basever}

# Simple Disk Sleep Monitor
%{__cc} %{rpmcppflags} %{rpmcflags} %{rpmldflags} Documentation/laptops/dslm.c -o dslm

# cpupower
%{__make} -C tools/power/cpupower \
	%{makeopts} \
	CPUFREQ_BENCH=false \
	OPTIMIZATION="%{rpmcflags}" \
	STRIPCMD=true

%ifarch %{ix86}
%{__make} -C tools/power/cpupower/debug/i386 centrino-decode powernow-k8-decode \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags}"
%endif

%ifarch %{x8664}
%{__make} -C tools/power/cpupower/debug/x86_64 centrino-decode powernow-k8-decode \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags}"
%endif

%ifarch %{ix86} %{x8664}
%{__make} -C tools/power/x86/x86_energy_perf_policy \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags}"
CFLAGS="%{rpmcflags}" \
%{__make} -C tools/power/x86/turbostat \
	CC="%{__cc}"
%endif

# page-types, slabinfo
%{__make} -C tools/vm page-types slabinfo \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} -Wall -Wextra -I../lib"

%if %{with perf}
%{__make} -C tools/perf all man \
	%{!?with_gtk:NO_GTK2=1} \
	%{makeopts} \
	CFLAGS_OPTIMIZE="%{rpmcflags}" \
	WERROR=0 \
	prefix=%{_prefix} \
	perfexecdir=%{_datadir}/perf-core \
	template_dir=%{_datadir}/perf-core/templates
%endif

# gen_init_cpio
%{__make} -C usr gen_init_cpio \
	%{makeopts} \
	CFLAGS="%{rpmcflags}"

%install
rm -rf $RPM_BUILD_ROOT

cd linux-%{basever}
install -d $RPM_BUILD_ROOT%{_sbindir}

%{__make} -C tools/power/cpupower install \
	DESTDIR=$RPM_BUILD_ROOT \
	libdir=%{_libdir} \
	mandir=%{_mandir} \
	CPUFREQ_BENCH=false

%find_lang cpupower
mv cpupower.lang ..

install -d $RPM_BUILD_ROOT{/etc/sysconfig,%{systemdunitdir}}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{systemdunitdir}/cpupower.service
cp -p %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/cpupower

%ifarch %{ix86}
install -p tools/power/cpupower/debug/i386/{centrino,powernow-k8}-decode $RPM_BUILD_ROOT%{_bindir}
%endif
%ifarch %{x8664}
install -p tools/power/cpupower/debug/x86_64/{centrino,powernow-k8}-decode $RPM_BUILD_ROOT%{_bindir}
%endif

install -p tools/vm/slabinfo $RPM_BUILD_ROOT%{_bindir}
install -p tools/vm/page-types $RPM_BUILD_ROOT%{_sbindir}
install -p dslm $RPM_BUILD_ROOT%{_sbindir}

%ifarch %{ix86} %{x8664}
install -d $RPM_BUILD_ROOT%{_mandir}/man8
# broken makefile, install manually
%if 0
%{__make} install \
	-C tools/power/x86/x86_energy_perf_policy \
	DESTDIR=$RPM_BUILD_ROOT
%else
cd tools/power/x86/x86_energy_perf_policy
install -p x86_energy_perf_policy $RPM_BUILD_ROOT%{_bindir}
cp -p x86_energy_perf_policy.8 $RPM_BUILD_ROOT%{_mandir}/man8
cd -
%endif

# broken makefile, install manually
%if 0
%{__make} install \
	-C tools/power/x86/turbostat \
	DESTDIR=$RPM_BUILD_ROOT
%else
cd tools/power/x86/turbostat
cp -p turbostat.8 $RPM_BUILD_ROOT%{_mandir}/man8
cd -
install -p turbostat $RPM_BUILD_ROOT%{_bindir}/turbostat
%endif
%endif

%if %{with perf}
%{__make} -j1 install install-man \
	-C tools/perf \
	%{!?with_gtk:NO_GTK2=1} \
	CC="%{__cc}" \
	CFLAGS_OPTIMIZE="%{rpmcflags}" \
	WERROR=0 \
	%{?with_verbose:V=1} \
	prefix=%{_prefix} \
	perfexecdir=%{_datadir}/perf-core \
	template_dir=%{_datadir}/perf-core/templates \
	DESTDIR=$RPM_BUILD_ROOT

%py_comp $RPM_BUILD_ROOT%{_datadir}/perf-core/scripts/python
%py_ocomp $RPM_BUILD_ROOT%{_datadir}/perf-core/scripts/python

%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/perf-core/tests
%endif

# gen_init_cpio
install -p usr/gen_init_cpio $RPM_BUILD_ROOT%{_bindir}/gen_init_cpio

%clean
rm -rf $RPM_BUILD_ROOT

%post	cpupower-libs -p /sbin/ldconfig
%postun	cpupower-libs -p /sbin/ldconfig

%post cpupower
%systemd_post cpupower.service

%preun cpupower
%systemd_preun cpupower.service

%postun cpupower
%systemd_reload

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/gen_init_cpio
%attr(755,root,root) %{_bindir}/slabinfo
%attr(755,root,root) %{_sbindir}/dslm
%attr(755,root,root) %{_sbindir}/page-types
%ifarch %{ix86} %{x8664}
%attr(755,root,root) %{_bindir}/centrino-decode
%attr(755,root,root) %{_bindir}/powernow-k8-decode
%endif
%ifarch %{ix86} %{x8664}
%attr(755,root,root) %{_bindir}/turbostat
%attr(755,root,root) %{_bindir}/x86_energy_perf_policy
%{_mandir}/man8/turbostat.8*
%{_mandir}/man8/x86_energy_perf_policy.8*
%endif

%files cpupower -f cpupower.lang
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/cpupower
%{_mandir}/man1/cpupower*.1*
%{systemdunitdir}/cpupower.service
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/cpupower

%files cpupower-libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcpupower.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcpupower.so.0

%files cpupower-libs-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcpupower.so
%{_includedir}/cpufreq.h

%if %{with perf}
%files perf
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/perf
%attr(755,root,root) %{_bindir}/trace
%{_mandir}/man1/perf*.1*
%dir %{_datadir}/perf-core
%attr(755,root,root) %{_datadir}/perf-core/perf-archive

%dir %{_datadir}/perf-core/scripts

%dir %{_datadir}/perf-core/scripts/perl
%dir %{_datadir}/perf-core/scripts/perl/Perf-Trace-Util
%dir %{_datadir}/perf-core/scripts/perl/Perf-Trace-Util/lib
%dir %{_datadir}/perf-core/scripts/perl/Perf-Trace-Util/lib/Perf
%dir %{_datadir}/perf-core/scripts/perl/Perf-Trace-Util/lib/Perf/Trace
%{_datadir}/perf-core/scripts/perl/Perf-Trace-Util/lib/Perf/Trace/*.pm
%dir %{_datadir}/perf-core/scripts/perl/bin
%attr(755,root,root) %{_datadir}/perf-core/scripts/perl/bin/*
%{_datadir}/perf-core/scripts/perl/*.pl

%dir %{_datadir}/perf-core/scripts/python
%dir %{_datadir}/perf-core/scripts/python/Perf-Trace-Util
%dir %{_datadir}/perf-core/scripts/python/Perf-Trace-Util/lib
%dir %{_datadir}/perf-core/scripts/python/Perf-Trace-Util/lib/Perf
%dir %{_datadir}/perf-core/scripts/python/Perf-Trace-Util/lib/Perf/Trace
%{_datadir}/perf-core/scripts/python/Perf-Trace-Util/lib/Perf/Trace/*.py*
%dir %{_datadir}/perf-core/scripts/python/bin
%attr(755,root,root) %{_datadir}/perf-core/scripts/python/bin/*
%{_datadir}/perf-core/scripts/python/*.py*

%dir %{_libdir}/traceevent
%dir %{_libdir}/traceevent/plugins
%attr(755,root,root) %{_libdir}/traceevent/plugins/plugin_*.so

%if %{with gtk}
%files perf-gtk
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libperf-gtk.so
%endif

%files -n bash-completion-perf
%defattr(644,root,root,755)
/etc/bash_completion.d/perf
%endif
%changelog
* Sat Nov 15 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/kernel-tools.git;a=log;h=master

* Sat Nov 15 2014 Jan Rękorajski <baggins@pld-linux.org> 497789c
- up to 3.17.3

* Mon Sep 15 2014 Jan Rękorajski <baggins@pld-linux.org> dad8cd2
- fixed perf packaging
- rel 2

* Sun Sep 14 2014 Jakub Bogusz <qboosh@pld-linux.org> 60ccbbd
- fixed libnuma BR

* Sun Sep 14 2014 Jan Rękorajski <baggins@pld-linux.org> f4d712b
- up to 3.16.2
- where is libnuma-devel qboosh?

* Fri Aug 29 2014 Jakub Bogusz <qboosh@pld-linux.org> ae4c1fd
- updated perf packaging: GTK+ interface is now module, so merged -core and -slang; perf-gtk is addon now

* Mon Aug 25 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> eb373af
- up to 3.16.1

* Sat Mar 15 2014 Elan Ruusamäe <glen@delfi.ee> 741b96d
- noarch bash completions

* Sat Mar 08 2014 Jakub Bogusz <qboosh@pld-linux.org> 4b35244
- updated to 3.10.33

* Wed Feb 26 2014 Elan Ruusamäe <glen@delfi.ee> d312b55
- rename perf to .sh ext and +x

* Wed Feb 26 2014 Elan Ruusamäe <glen@delfi.ee> 9efc8fe
- adapter

* Wed Feb 26 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> c6e8d46
- perf-core: S: binutils

* Wed Feb 26 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 35be646
- A wrapper 'perf' script added

* Tue Jan 28 2014 Jan Rękorajski <baggins@pld-linux.org> eafb79c
- release 2 (by relup.sh)

* Wed Jan 22 2014 Jan Rękorajski <baggins@pld-linux.org> f0dde21
- 3.10.27

* Wed Dec 04 2013 Jan Rękorajski <baggins@pld-linux.org> ba61bbe
- 3.10.22

* Tue Dec 03 2013 Jan Rękorajski <baggins@pld-linux.org> 3b4ac2b
- up to 3.10.21

* Tue Nov 19 2013 Sławomir Paszkiewicz <paszczus@pld-linux.org> 8202c6d
- updated md5

* Tue Nov 19 2013 Sławomir Paszkiewicz <paszczus@pld-linux.org> ee26013
- updated for 3.10.19

* Fri Nov 15 2013 Elan Ruusamäe <glen@delfi.ee> a8b28c3
- cleanup BRs regarding bconds

* Fri Nov 15 2013 Elan Ruusamäe <glen@delfi.ee> 4a7175d
- update BR

